#include "Arduino.h"
#include "HCSR04.h"

//Contructor//
HCSR04ProxSensor::HCSR04ProxSensor(int echoPin, int triggerPin) {
  this->echoPin = echoPin;
  this->triggerPin = triggerPin;
  this->lastDistance = 0;
  this->currentDistance = 0;
  pinMode(triggerPin, OUTPUT);
  pinMode(echoPin, INPUT);
}

//Initial Distance Readings//
float HCSR04ProxSensor::readSensor(){
  long pulse, cm;
  //digitalWrite(triggerPin, LOW);           //Not needed, however this makes sure the triggerPin is low
  //delayMicroseconds(2);
  digitalWrite(this->triggerPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(this->triggerPin, LOW);
  pulse = pulseIn(this->echoPin,HIGH);
  cm = pulse/29/2;                           //Speed of sound in centimeters is 29 microseconds per centimeter, and the ping travels back and forth thus divide by two
  this->lastDistance = this->currentDistance;
  this->currentDistance = cm;
  return cm;
}

//Compares Distances//
float HCSR04ProxSensor::getLastValue(){
  return this->lastDistance;
}




